/**
 * 
 */
package net.clearfly.sandbox.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;
import org.richfaces.model.DataProvider;
import org.richfaces.model.ExtendedTableDataModel;
import org.richfaces.model.selection.Selection;
import org.richfaces.model.selection.SimpleSelection;

@Scope(ScopeType.CONVERSATION)
@Name("carTableBean")
public class CarTableBean implements Serializable {

	private static final long serialVersionUID = 1L;
	private String sortMode = "single";
	private String selectionMode = "multi";
	private Object tableState;
	private Selection selection = new SimpleSelection();
	private List<Car> cars = buildCarsList();
	private ExtendedTableDataModel<Car> dataModel;
	private List<Car> selectedCars = new ArrayList<Car>();

	public String getSortMode() {
		return sortMode;
	}

	public void setSortMode(String sortMode) {
		this.sortMode = sortMode;
	}

	public String getSelectionMode() {
		return selectionMode;
	}

	public void setSelectionMode(String selectionMode) {
		this.selectionMode = selectionMode;
	}

	public CarTableBean() {
	}

	public void takeSelection() {
		selectedCars.clear();
		Iterator<Object> iterator = getSelection().getKeys();
		while (iterator.hasNext()) {
			Object key = iterator.next();
			System.out.println("Take Selection has Key: " + key);
			selectedCars.add(getCarsDataModel().getObjectByKey(key));
		}
	}

	public ExtendedTableDataModel<Car> getCarsDataModel() {
		if (dataModel == null) {
			dataModel = new ExtendedTableDataModel<Car>(
					new DataProvider<Car>() {

						private static final long serialVersionUID = 5054087821033164847L;

						public Car getItemByKey(Object key) {
							System.out.println("GetItemByKey Called with Key: " + key);
							for (Car c : cars) {
								if (key.equals(getKey(c))) {
									System.out.println("GetItemByKey Returing: " + c.getId());
									return c;
								}
							}
							System.out.println("GetItemByKey Returing: NULL");
							return null;
						}

						public List<Car> getItemsByRange(int firstRow,
								int endRow) {
							System.out.println("getItemsByRange Returing: " + firstRow + " , " + endRow);
							return cars.subList(firstRow, endRow);
						}

						public Object getKey(Car item) {
							System.out.println("GetKey Returing: " + item.getId() + " for " + item.getName());
							return item.getId();
						}

						public int getRowCount() {
							System.out.println("GetRowCount Returing: " + cars.size());
							return cars.size();
						}

					});
		}
		return dataModel;
	}

	public void setCars(List<Car> cars) {
		this.cars = cars;
	}

	public Object getTableState() {
		return tableState;
	}

	public void setTableState(Object tableState) {
		this.tableState = tableState;
	}

	public Selection getSelection() {
		return selection;
	}

	public void setSelection(Selection selection) {
		this.selection = selection;
	}

	public List<Car> getSelectedCars() {
		return selectedCars;
	}

	public void setSelectedCars(List<Car> selectedCars) {
		this.selectedCars = selectedCars;
	}
	
	private List<Car> buildCarsList()
	{
		List<Car> cars = new ArrayList<Car>();
		
		cars.add(new Car(100,"Audi",49999.99d));
		cars.add(new Car(200,"BMW",39999.99d));
		cars.add(new Car(300,"Toyota",29999.99d));
		cars.add(new Car(400,"Honda",19999.99d));
		cars.add(new Car(500,"Kia",19999.99d));
		
		return cars;
	}

}